ps_latnode_s Struct Reference

DAG nodes. More...

`#include <ps_lattice_internal.h>`

## Data Fields

int32 | id
| Unique id for this node.
int32 | wid
| Dictionary word id.
int32 | basewid
| Dictionary base word id.
int32 | fef
| First end frame.
int32 | lef
| Last end frame.
frame_idx_t | sf
| Start frame.
int16 | reachable
| From.
int32 | node_id
| Node from fsg model, used to map lattice back to model.
union { |
glist_t velist |
| List of history entries with different lmstate (tst only) More...
int32 fanin |
| Number nodes with links to this node. More...
int32 rem_score |
| Estimated best score from node.sf to end. More...
int32 best_exit |
| Best exit score (used for final nodes only) More...
} | info |
latlink_list_t * | exits
| Links out of this node.
latlink_list_t * | entries
| Links into this node.
struct ps_latnode_s * | alt
| Node with alternate pronunciation for this word.
struct ps_latnode_s * | next
| Next node in DAG (no ordering implied)

## Detailed Description

DAG nodes.

A node corresponds to a number of hypothesized instances of a word which all share the same starting point.

Definition at line 113 of file ps_lattice_internal.h.

## Field Documentation

## alt

struct ps_latnode_s* ps_latnode_s::alt

Node with alternate pronunciation for this word.

Definition at line 132 of file ps_lattice_internal.h.

Referenced by ngram_search_lattice().

## basewid

int32 ps_latnode_s::basewid

Dictionary base word id.

Definition at line 116 of file ps_lattice_internal.h.

Referenced by ngram_search_lattice(), ps_astar_hyp(), ps_astar_start(), ps_latlink_baseword(), ps_latnode_baseword(), ps_lattice_bestpath(), ps_lattice_hyp(), ps_lattice_penalize_fillers(), ps_lattice_posterior(), and ps_lattice_read().

## best_exit

int32 ps_latnode_s::best_exit

Best exit score (used for final nodes only)

Definition at line 127 of file ps_lattice_internal.h.

## entries

latlink_list_t* ps_latnode_s::entries

Links into this node.

Definition at line 130 of file ps_lattice_internal.h.

Referenced by ps_latnode_entries(), ps_lattice_bestpath(), ps_lattice_link(), ps_lattice_penalize_fillers(), ps_lattice_posterior_prune(), ps_lattice_read(), ps_lattice_reverse_edges(), and ps_lattice_reverse_next().

## exits

latlink_list_t* ps_latnode_s::exits

Links out of this node.

Definition at line 129 of file ps_lattice_internal.h.

Referenced by ps_astar_start(), ps_latnode_exits(), ps_latnode_prob(), ps_lattice_bestpath(), ps_lattice_link(), ps_lattice_posterior(), ps_lattice_posterior_prune(), ps_lattice_read(), ps_lattice_reverse_edges(), ps_lattice_traverse_edges(), ps_lattice_traverse_next(), ps_lattice_write(), and ps_lattice_write_htk().

## fanin

int32 ps_latnode_s::fanin

Number nodes with links to this node.

Definition at line 125 of file ps_lattice_internal.h.

Referenced by ps_lattice_reverse_edges(), ps_lattice_reverse_next(), ps_lattice_traverse_edges(), and ps_lattice_traverse_next().

## fef

int32 ps_latnode_s::fef

First end frame.

Definition at line 118 of file ps_lattice_internal.h.

Referenced by ngram_search_lattice(), ps_astar_next(), ps_latnode_times(), ps_lattice_read(), and ps_lattice_write().

## id

int32 ps_latnode_s::id

Unique id for this node.

Definition at line 114 of file ps_lattice_internal.h.

Referenced by ps_lattice_delete_unreachable(), ps_lattice_read(), ps_lattice_write(), and ps_lattice_write_htk().

## lef

int32 ps_latnode_s::lef

Last end frame.

Definition at line 119 of file ps_lattice_internal.h.

Referenced by ngram_search_lattice(), ps_latnode_times(), ps_lattice_bestpath(), ps_lattice_read(), and ps_lattice_write().

## next

struct ps_latnode_s* ps_latnode_s::next

Next node in DAG (no ordering implied)

Definition at line 133 of file ps_lattice_internal.h.

Referenced by ngram_search_lattice(), ps_astar_start(), ps_latnode_iter_next(), ps_lattice_bestpath(), ps_lattice_delete_unreachable(), ps_lattice_penalize_fillers(), ps_lattice_posterior(), ps_lattice_read(), ps_lattice_reverse_edges(), ps_lattice_traverse_edges(), ps_lattice_write(), and ps_lattice_write_htk().

## node_id

int32 ps_latnode_s::node_id

Node from fsg model, used to map lattice back to model.

Definition at line 122 of file ps_lattice_internal.h.

Referenced by ps_lattice_write().

## reachable

int16 ps_latnode_s::reachable

From.

    </s>

or

    <s>

Definition at line 121 of file ps_lattice_internal.h.

Referenced by ngram_search_lattice(), ps_lattice_delete_unreachable(), ps_lattice_posterior_prune(), ps_lattice_read(), and ps_lattice_write_htk().

## rem_score

int32 ps_latnode_s::rem_score

Estimated best score from node.sf to end.

Definition at line 126 of file ps_lattice_internal.h.

Referenced by ps_astar_start().

## sf

frame_idx_t ps_latnode_s::sf

Start frame.

Definition at line 120 of file ps_lattice_internal.h.

Referenced by ngram_search_lattice(), ps_astar_next(), ps_astar_start(), ps_latlink_times(), ps_latnode_times(), ps_lattice_bestpath(), ps_lattice_read(), ps_lattice_write(), and ps_lattice_write_htk().

## velist

glist_t ps_latnode_s::velist

List of history entries with different lmstate (tst only)

Definition at line 124 of file ps_lattice_internal.h.

## wid

int32 ps_latnode_s::wid

Dictionary word id.

Definition at line 115 of file ps_lattice_internal.h.

Referenced by ngram_search_lattice(), ps_latlink_word(), ps_latnode_word(), ps_lattice_bestpath(), ps_lattice_read(), ps_lattice_write(), and ps_lattice_write_htk().

The documentation for this struct was generated from the following file:

- src/libpocketsphinx/ps_lattice_internal.h